// ArrowButtonTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ArrowButtonTestDlg.h"
#include "ToClip.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CArrowButtonTestDlg dialog



CArrowButtonTestDlg::CArrowButtonTestDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CArrowButtonTestDlg::IDD, pParent)
   {
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    initialized = FALSE;
   }

/****************************************************************************
*                     CArrowButtonTestDlg::DoDataExchange
* Inputs:
*       CDataExchange * pDX:
* Result: void
*       
* Effect: 
*       Binds controls to variables
****************************************************************************/

void CArrowButtonTestDlg::DoDataExchange(CDataExchange* pDX)
   {
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_N, c_N);
    DDX_Control(pDX, IDC_S, c_S);
    DDX_Control(pDX, IDC_E, c_E);
    DDX_Control(pDX, IDC_W, c_W);
    DDX_Control(pDX, IDC_VERTICAL, c_Vertical);
    DDX_Control(pDX, IDC_HORIZONTAL, c_Horizontal);
    DDX_Control(pDX, IDC_ENABLE, c_Enable);
    DDX_Control(pDX, IDC_SPINWIDTH, c_SpinWidth);
    DDX_Control(pDX, IDC_SPINHEIGHT, c_SpinHeight);
    DDX_Control(pDX, IDC_BUTTON, c_Button);
    DDX_Control(pDX, IDC_BUTTONFRAME, c_ButtonFrame);
    DDX_Control(pDX, IDC_TEXT_COLOR, c_TextColor);
    DDX_Control(pDX, IDC_BODY_COLOR, c_BodyColor);
    DDX_Control(pDX, IDC_LINE_COLOR, c_LineColor);
    DDX_Control(pDX, IDC_TEXT, c_Text);
    DDX_Control(pDX, IDC_LEFT_ALIGN, c_LeftAlign);
    DDX_Control(pDX, IDC_CENTER_ALIGN, c_CenterAlign);
    DDX_Control(pDX, IDC_RIGHT_ALIGN, c_RightAlign);
   }

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CArrowButtonTestDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        //}}AFX_MSG_MAP
        ON_BN_CLICKED(IDC_VERTICAL, OnBnClickedVertical)
        ON_BN_CLICKED(IDC_HORIZONTAL, OnBnClickedHorizontal)
        ON_EN_CHANGE(IDC_WIDTH, OnEnChangeWidth)
        ON_EN_CHANGE(IDC_HEIGHT, OnEnChangeHeight)
        ON_BN_CLICKED(IDC_ENABLE, OnBnClickedEnable)
        ON_BN_CLICKED(IDC_N, OnBnClickedN)
        ON_BN_CLICKED(IDC_S, OnBnClickedS)
        ON_BN_CLICKED(IDC_E, OnBnClickedE)
        ON_BN_CLICKED(IDC_W, OnBnClickedW)
        ON_BN_CLICKED(IDC_SET_TEXT_COLOR, OnBnClickedSetTextColor)
        ON_BN_CLICKED(IDC_SET_LINE_COLOR, OnBnClickedSetLineColor)
        ON_BN_CLICKED(IDC_SET_BODY_COLOR, OnBnClickedSetBodyColor)
        ON_EN_CHANGE(IDC_TEXT, OnEnChangeText)
        ON_BN_CLICKED(IDC_LEFT_ALIGN, OnBnClickedLeftAlign)
        ON_BN_CLICKED(IDC_CENTER_ALIGN, OnBnClickedCenterAlign)
        ON_BN_CLICKED(IDC_RIGHT_ALIGN, OnBnClickedRightAlign)
        ON_BN_CLICKED(IDC_COPY, OnBnClickedCopy)
END_MESSAGE_MAP()

/****************************************************************************
*                      CArrowButtonTestDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CArrowButtonTestDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon

    // TODO: Add extra initialization here
    CRect r;
    c_ButtonFrame.GetWindowRect(&r);
    int dim = min(r.Width(), r.Height());
    c_SpinWidth.SetRange(1, dim);
    c_SpinHeight.SetRange(1, dim);

    CheckRadioButton(IDC_N, IDC_W, IDC_E);  
    c_Button.GetWindowRect(&r);
    c_SpinWidth.SetPos(r.Width());
    c_SpinHeight.SetPos(r.Height());

    CheckRadioButton(IDC_VERTICAL, IDC_HORIZONTAL, IDC_HORIZONTAL);
    mode = CDirection::HORIZONTAL;

    c_LineColor.SetColor(c_Button.GetLineColor());
    c_BodyColor.SetColor(c_Button.GetBodyColor());
    c_TextColor.SetColor(c_Button.GetTextColor());
    CString s;
    c_Button.GetWindowText(s);
    c_Text.SetWindowText(s);

    CheckRadioButton(IDC_LEFT_ALIGN, IDC_RIGHT_ALIGN, IDC_LEFT_ALIGN);

    initialized = TRUE;
    updateControls();
    return TRUE;  // return TRUE  unless you set the focus to a control
   }

/****************************************************************************
*                      CArrowButtonTestDlg::OnSysCommand
* Inputs:
*       UINT nID:
*       LPARAM lParam:
* Result: void
*       
* Effect: 
*       Handles extended system menu
****************************************************************************/

void CArrowButtonTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

/****************************************************************************
*                        CArrowButtonTestDlg::OnPaint
* Result: void
*       
* Effect: 
*       If you add a minimize button to your dialog, you will need the code
*       below to draw the icon.  For MFC applications using the document/view
*       model, this is automatically done for you by the framework.
****************************************************************************/

void CArrowButtonTestDlg::OnPaint() 
   {
    if (IsIconic())
       {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
       }
    else
       {
        CDialog::OnPaint();
       }
   }

/****************************************************************************
*                      CArrowButtonTestDlg::OnQueryIcon
* Result: HCURSOR
*       Actually the icon
* Effect: 
*       The system calls this function to obtain the cursor to display while
*       the user drags the minimized window.
****************************************************************************/

HCURSOR CArrowButtonTestDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                  CArrowButtonTestDlg::OnBnClickedVertical
* Result: void
*       
* Effect: 
*       Draws the button vertically
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedVertical()
    {
     if(mode == CDirection::VERTICAL)
        return;
     int t = c_SpinHeight.GetPos32();
     c_SpinHeight.SetPos32(c_SpinWidth.GetPos32());
     c_SpinWidth.SetPos32(t);
     mode = CDirection::VERTICAL;
     updateControls();
    }

/****************************************************************************
*                 CArrowButtonTestDlg::OnBnClickedHorizontal
* Result: void
*       
* Effect: 
*       Draws the button horizontally
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedHorizontal()
    {
     if(mode == CDirection::HORIZONTAL)
        return;
     int t = c_SpinHeight.GetPos32();
     c_SpinHeight.SetPos32(c_SpinWidth.GetPos32());
     c_SpinWidth.SetPos32(t);
     mode = CDirection::HORIZONTAL;
     updateControls();
    }

/****************************************************************************
*                     CArrowButtonTestDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CArrowButtonTestDlg::updateControls()
    {
     if(!initialized)
         return;
     
     int h = c_SpinHeight.GetPos32();
     int w = c_SpinWidth.GetPos32();

     CRect r;
     c_ButtonFrame.GetWindowRect(&r);
     ScreenToClient(&r);

     c_Button.SetWindowPos(NULL,
                           r.left + (r.Width() - w) / 2,
                           r.top +  (r.Height() - h) / 2,
                           w, h,
                           SWP_NOZORDER);

     DrawArrow::Direction dir;
     if(c_N.GetCheck() == BST_CHECKED)
        dir = DrawArrow::ARROW_N;
     else
     if(c_S.GetCheck() == BST_CHECKED)
        dir = DrawArrow::ARROW_S;
     else
     if(c_E.GetCheck() == BST_CHECKED)
        dir = DrawArrow::ARROW_E;
     else
     if(c_W.GetCheck() == BST_CHECKED)
        dir = DrawArrow::ARROW_W;
     else
        dir = DrawArrow::ARROW_NONE;
     c_Button.SetDirection(dir);
     c_Button.EnableWindow(c_Enable.GetCheck() == BST_CHECKED);

     DWORD style = BS_LEFT;
     if(c_LeftAlign.GetCheck() == BST_CHECKED)
        style = BS_LEFT;
     else
     if(c_CenterAlign.GetCheck() == BST_CHECKED)
        style = BS_CENTER;
     else
     if(c_RightAlign.GetCheck() == BST_CHECKED)
        style = BS_RIGHT;

     DWORD oldstyle = c_Button.GetStyle();
     c_Button.ModifyStyle(BS_LEFT | BS_RIGHT | BS_CENTER, style);
     if( (oldstyle & (BS_LEFT | BS_RIGHT | BS_CENTER)) != style)
        c_Button.Invalidate();
    } // CArrowButtonTestDlg::updateControls

/****************************************************************************
*                    CArrowButtonTestDlg::OnEnChangeWidth
* Result: void
*       
* Effect: 
*       Handles change in the width
****************************************************************************/

void CArrowButtonTestDlg::OnEnChangeWidth()
    {
     updateControls();
    }

void CArrowButtonTestDlg::OnEnChangeHeight()
    {
     updateControls();
    }

/****************************************************************************
*                   CArrowButtonTestDlg::OnBnClickedEnable
* Result: void
*       
* Effect: 
*       Handles change in the enable state
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedEnable()
    {
     updateControls();
    }

/****************************************************************************
*                      CArrowButtonTestDlg::OnBnClickedN
* Result: void
*       
* Effect: 
*       Sets arrow to point up
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedN()
    {
     updateControls();
    }

/****************************************************************************
*                     CArrowButtonTestDlg::OnBnCllickedS
* Result: void
*       
* Effect: 
*       Sets the arrow to point down
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedS()
    {
     updateControls();
    }

/****************************************************************************
*                      CArrowButtonTestDlg::OnBnClickedE
* Result: void
*       
* Effect: 
*       Sets arrow to point right
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedE()
    {
     updateControls();
    }

/****************************************************************************
*                      CArrowButtonTestDlg::OnBnClickedW
* Result: void
*       
* Effect: 
*       Sets arrow to point left
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedW()
    {
     updateControls();
    }

/****************************************************************************
*                CArrowButtonTestDlg::OnBnCLlickedSetLineColor
* Result: void
*       
* Effect: 
*       Sets the line color
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedSetLineColor()
    {
     COLORREF c = c_Button.GetLineColor();
     CColorDialog dlg(c);
     if(dlg.DoModal() != IDOK)
        return;
     c = dlg.GetColor();
     c_LineColor.SetColor(c);
     c_Button.SetLineColor(c);
    }

/****************************************************************************
*               CArrowButtonTestDlg::OnBnCLickedSetBodyColor
* Result: void
*       
* Effect: 
*       Changes the body color
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedSetBodyColor()
    {
     COLORREF c = c_Button.GetBodyColor();
     CColorDialog dlg(c);
     if(dlg.DoModal() != IDOK)
        return;
     c = dlg.GetColor();
     c_BodyColor.SetColor(c);
     c_Button.SetBodyColor(c);
    }

/****************************************************************************
*                CArrowButtonTestDlg::OnBnClickedSetTextColor
* Result: void
*       
* Effect: 
*       Sets the text color
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedSetTextColor()
    {
     COLORREF c = c_Button.GetTextColor();
     CColorDialog dlg(c);
     if(dlg.DoModal() != IDOK)
        return;
     c = dlg.GetColor();
     c_TextColor.SetColor(c);
     c_Button.SetTextColor(c);
    } // CArrowButtonTestDlg::OnBnClickedSetTextColor

#if 0
struct {
   BYTE op;
   UINT BLTOP;
   LPCTSTR name;
}
trops[] = {
    { 0x00, 0x00000042, _T("0 BLACKNESS") },
    { 0x01, 0x00010289, _T("DPSoon") },
    { 0x02, 0x00020C89, _T("DPSona") },
    { 0x03, 0x000300AA, _T("PSon") },
    { 0x04, 0x00040C88, _T("SDPona") },
    { 0x05, 0x000500A9, _T("DPon") },
    { 0x06, 0x00060865, _T("PDSxnon") },
    { 0x07, 0x000702C5, _T("PDSaon") },
    { 0x08, 0x00080F08, _T("SDPnaa") },
    { 0x09, 0x00090245, _T("PDSxon") },
    { 0x0A, 0x000A0329, _T("DPna") },
    { 0x0B, 0x000B0B2A, _T("PSDnaon") },
    { 0x0C, 0x000C0324, _T("SPna") },
    { 0x0D, 0x000D0B25, _T("PDSnaon") },
    { 0x0E, 0x000E08A5, _T("PDSonon") },
    { 0x0F, 0x000F0001, _T("Pn") },
    { 0x10, 0x00100C85, _T("PDSona") },
    { 0x11, 0x001100A6, _T("DSon NOTSRCERASE") },
    { 0x12, 0x00120868, _T("SDPxnon") },
    { 0x13, 0x001302C8, _T("SDPaon") },
    { 0x14, 0x00140869, _T("DPSxnon") },
    { 0x15, 0x001502C9, _T("DPSaon") },
    { 0x16, 0x00165CCA, _T("PSDPSanaxx") },
    { 0x17, 0x00171D54, _T("SSPxDSxaxn") },
    { 0x18, 0x00180D59, _T("SPxPDxa") },
    { 0x19, 0x00191CC8, _T("SDPSanaxn") },
    { 0x1A, 0x001A06C5, _T("PDSPaox") },
    { 0x1B, 0x001B0768, _T("SDPSxaxn") },
    { 0x1C, 0x001C06CA, _T("PSDPaox") },
    { 0x1D, 0x001D0766, _T("DSPDxaxn") },
    { 0x1E, 0x001E01A5, _T("PDSox") },
    { 0x1F, 0x001F0385, _T("PDSoan") },
    { 0x20, 0x00200F09, _T("DPSnaa") },
    { 0x21, 0x00210248, _T("SDPxon") },
    { 0x22, 0x00220326, _T("DSna") },
    { 0x23, 0x00230B24, _T("SPDnaon") },
    { 0x24, 0x00240D55, _T("SPxDSxa") },
    { 0x25, 0x00251CC5, _T("PDSPanaxn") },
    { 0x26, 0x002606C8, _T("SDPSaox") },
    { 0x27, 0x00271868, _T("SDPSxnox") },
    { 0x28, 0x00280369, _T("DPSxa") },
    { 0x29, 0x002916CA, _T("PSDPSaoxxn") },
    { 0x2A, 0x002A0CC9, _T("DPSana") },
    { 0x2B, 0x002B1D58, _T("SSPxPDxaxn") },
    { 0x2C, 0x002C0784, _T("SPDSoax") },
    { 0x2D, 0x002D060A, _T("PSDnox") },
    { 0x2E, 0x002E064A, _T("PSDPxox") },
    { 0x2F, 0x002F0E2A, _T("PSDnoan") },
    { 0x30, 0x0030032A, _T("PSna") },
    { 0x31, 0x00310B28, _T("SDPnaon") },
    { 0x32, 0x00320688, _T("SDPSoox") },
    { 0x33, 0x00330008, _T("Sn NOTSRCCOPY") },
    { 0x34, 0x003406C4, _T("SPDSaox") },
    { 0x35, 0x00351864, _T("SPDSxnox") },
    { 0x36, 0x003601A8, _T("SDPox") },
    { 0x37, 0x00370388, _T("SDPoan") },
    { 0x38, 0x0038078A, _T("PSDPoax") },
    { 0x39, 0x00390604, _T("SPDnox") },
    { 0x3A, 0x003A0644, _T("SPDSxox") },
    { 0x3B, 0x003B0E24, _T("SPDnoan") },
    { 0x3C, 0x003C004A, _T("PSx") },
    { 0x3D, 0x003D18A4, _T("SPDSonox") },
    { 0x3E, 0x003E1B24, _T("SPDSnaox") },
    { 0x3F, 0x003F00EA, _T("PSan") },
    { 0x40, 0x00400F0A, _T("PSDnaa") },
    { 0x41, 0x00410249, _T("DPSxon") },
    { 0x42, 0x00420D5D, _T("SDxPDxa") },
    { 0x43, 0x00431CC4, _T("SPDSanaxn") },
    { 0x44, 0x00440328, _T("SDna SRCERASE") },
    { 0x45, 0x00450B29, _T("DPSnaon") },
    { 0x46, 0x004606C6, _T("DSPDaox") },
    { 0x47, 0x0047076A, _T("PSDPxaxn") },
    { 0x48, 0x00480368, _T("SDPxa") },
    { 0x49, 0x004916C5, _T("PDSPDaoxxn") },
    { 0x4A, 0x004A0789, _T("DPSDoax") },
    { 0x4B, 0x004B0605, _T("PDSnox") },
    { 0x4C, 0x004C0CC8, _T("SDPana") },
    { 0x4D, 0x004D1954, _T("SSPxDSxoxn") },
    { 0x4E, 0x004E0645, _T("PDSPxox") },
    { 0x4F, 0x004F0E25, _T("PDSnoan") },
    { 0x50, 0x00500325, _T("PDna") },
    { 0x51, 0x00510B26, _T("DSPnaon") },
    { 0x52, 0x005206C9, _T("DPSDaox") },
    { 0x53, 0x00530764, _T("SPDSxaxn") },
    { 0x54, 0x005408A9, _T("DPSonon") },
    { 0x55, 0x00550009, _T("Dn DSTINVERT") },
    { 0x56, 0x005601A9, _T("DPSox") },
    { 0x57, 0x00570389, _T("DPSoan") },
    { 0x58, 0x00580785, _T("PDSPoax") },
    { 0x59, 0x00590609, _T("DPSnox") },
    { 0x5A, 0x005A0049, _T("DPx PATINVERT") },
    { 0x5B, 0x005B18A9, _T("DPSDonox") },
    { 0x5C, 0x005C0649, _T("DPSDxox") },
    { 0x5D, 0x005D0E29, _T("DPSnoan") },
    { 0x5E, 0x005E1B29, _T("DPSDnaox") },
    { 0x5F, 0x005F00E9, _T("DPan") },
    { 0x60, 0x00600365, _T("PDSxa") },
    { 0x61, 0x006116C6, _T("DSPDSaoxxn") },
    { 0x62, 0x00620786, _T("DSPDoax") },
    { 0x63, 0x00630608, _T("SDPnox") },
    { 0x64, 0x00640788, _T("SDPSoax") },
    { 0x65, 0x00650606, _T("DSPnox") },
    { 0x66, 0x00660046, _T("DSx SRCINVERT") },
    { 0x67, 0x006718A8, _T("SDPSonox") },
    { 0x68, 0x006858A6, _T("DSPDSonoxxn") },
    { 0x69, 0x00690145, _T("PDSxxn") },
    { 0x6A, 0x006A01E9, _T("DPSax") },
    { 0x6B, 0x006B178A, _T("PSDPSoaxxn") },
    { 0x6C, 0x006C01E8, _T("SDPax") },
    { 0x6D, 0x006D1785, _T("PDSPDoaxxn") },
    { 0x6E, 0x006E1E28, _T("SDPSnoax") },
    { 0x6F, 0x006F0C65, _T("PDSxnan") },
    { 0x70, 0x00700CC5, _T("PDSana") },
    { 0x71, 0x00711D5C, _T("SSDxPDxaxn") },
    { 0x72, 0x00720648, _T("SDPSxox") },
    { 0x73, 0x00730E28, _T("SDPnoan") },
    { 0x74, 0x00740646, _T("DSPDxox") },
    { 0x75, 0x00750E26, _T("DSPnoan") },
    { 0x76, 0x00761B28, _T("SDPSnaox") },
    { 0x77, 0x007700E6, _T("DSan") },
    { 0x78, 0x007801E5, _T("PDSax") },
    { 0x79, 0x00791786, _T("DSPDSoaxxn") },
    { 0x7A, 0x007A1E29, _T("DPSDnoax") },
    { 0x7B, 0x007B0C68, _T("SDPxnan") },
    { 0x7C, 0x007C1E24, _T("SPDSnoax") },
    { 0x7D, 0x007D0C69, _T("DPSxnan") },
    { 0x7E, 0x007E0955, _T("SPxDSxo") },
    { 0x7F, 0x007F03C9, _T("DPSaan") },
    { 0x80, 0x008003E9, _T("DPSaa") },
    { 0x81, 0x00810975, _T("SPxDSxon") },
    { 0x82, 0x00820C49, _T("DPSxna") },
    { 0x83, 0x00831E04, _T("SPDSnoaxn") },
    { 0x84, 0x00840C48, _T("SDPxna") },
    { 0x85, 0x00851E05, _T("PDSPnoaxn") },
    { 0x86, 0x008617A6, _T("DSPDSoaxx") },
    { 0x87, 0x008701C5, _T("PDSaxn") },
    { 0x88, 0x008800C6, _T("DSa SRCAND") },
    { 0x89, 0x00891B08, _T("SDPSnaoxn") },
    { 0x8A, 0x008A0E06, _T("DSPnoa") },
    { 0x8B, 0x008B0666, _T("DSPDxoxn") },
    { 0x8C, 0x008C0E08, _T("SDPnoa") },
    { 0x8D, 0x008D0668, _T("SDPSxoxn") },
    { 0x8E, 0x008E1D7C, _T("SSDxPDxax") },
    { 0x8F, 0x008F0CE5, _T("PDSanan") },
    { 0x90, 0x00900C45, _T("PDSxna") },
    { 0x91, 0x00911E08, _T("SDPSnoaxn") },
    { 0x92, 0x009217A9, _T("DPSDPoaxx") },
    { 0x93, 0x009301C4, _T("SPDaxn") },
    { 0x94, 0x009417AA, _T("PSDPSoaxx") },
    { 0x95, 0x009501C9, _T("DPSaxn") },
    { 0x96, 0x00960169, _T("DPSxx") },
    { 0x97, 0x0097588A, _T("PSDPSonoxx") },
    { 0x98, 0x00981888, _T("SDPSonoxn") },
    { 0x99, 0x00990066, _T("DSxn") },
    { 0x9A, 0x009A0709, _T("DPSnax") },
    { 0x9B, 0x009B07A8, _T("SDPSoaxn") },
    { 0x9C, 0x009C0704, _T("SPDnax") },
    { 0x9D, 0x009D07A6, _T("DSPDoaxn") },
    { 0x9E, 0x009E16E6, _T("DSPDSaoxx") },
    { 0x9F, 0x009F0345, _T("PDSxan") },
    { 0xA0, 0x00A000C9, _T("DPa") },
    { 0xA1, 0x00A11B05, _T("PDSPnaoxn") },
    { 0xA2, 0x00A20E09, _T("DPSnoa") },
    { 0xA3, 0x00A30669, _T("DPSDxoxn") },
    { 0xA4, 0x00A41885, _T("PDSPonoxn") },
    { 0xA5, 0x00A50065, _T("PDxn") },
    { 0xA6, 0x00A60706, _T("DSPnax") },
    { 0xA7, 0x00A707A5, _T("PDSPoaxn") },
    { 0xA8, 0x00A803A9, _T("DPSoa") },
    { 0xA9, 0x00A90189, _T("DPSoxn") },
    { 0xAA, 0x00AA0029, _T("D") },
    { 0xAB, 0x00AB0889, _T("DPSono") },
    { 0xAC, 0x00AC0744, _T("SPDSxax") },
    { 0xAD, 0x00AD06E9, _T("DPSDaoxn") },
    { 0xAE, 0x00AE0B06, _T("DSPnao") },
    { 0xAF, 0x00AF0229, _T("DPno") },
    { 0xB0, 0x00B00E05, _T("PDSnoa") },
    { 0xB1, 0x00B10665, _T("PDSPxoxn") },
    { 0xB2, 0x00B21974, _T("SSPxDSxox") },
    { 0xB3, 0x00B30CE8, _T("SDPanan") },
    { 0xB4, 0x00B4070A, _T("PSDnax") },
    { 0xB5, 0x00B507A9, _T("DPSDoaxn") },
    { 0xB6, 0x00B616E9, _T("DPSDPaoxx") },
    { 0xB7, 0x00B70348, _T("SDPxan") },
    { 0xB8, 0x00B8074A, _T("PSDPxax") },
    { 0xB9, 0x00B906E6, _T("DSPDaoxn") },
    { 0xBA, 0x00BA0B09, _T("DPSnao") },
    { 0xBB, 0x00BB0226, _T("DSno MERGEPAINT") },
    { 0xBC, 0x00BC1CE4, _T("SPDSanax") },
    { 0xBD, 0x00BD0D7D, _T("SDxPDxan") },
    { 0xBE, 0x00BE0269, _T("DPSxo") },
    { 0xBF, 0x00BF08C9, _T("DPSano") },
    { 0xC0, 0x00C000CA, _T("PSa MERGECOPY") },
    { 0xC1, 0x00C11B04, _T("SPDSnaoxn") },
    { 0xC2, 0x00C21884, _T("SPDSonoxn") },
    { 0xC3, 0x00C3006A, _T("PSxn") },
    { 0xC4, 0x00C40E04, _T("SPDnoa") },
    { 0xC5, 0x00C50664, _T("SPDSxoxn") },
    { 0xC6, 0x00C60708, _T("SDPnax") },
    { 0xC7, 0x00C707AA, _T("PSDPoaxn") },
    { 0xC8, 0x00C803A8, _T("SDPoa") },
    { 0xC9, 0x00C90184, _T("SPDoxn") },
    { 0xCA, 0x00CA0749, _T("DPSDxax") },
    { 0xCB, 0x00CB06E4, _T("SPDSaoxn") },
    { 0xCC, 0x00CC0020, _T("S SRCCOPY") },
    { 0xCD, 0x00CD0888, _T("SDPono") },
    { 0xCE, 0x00CE0B08, _T("SDPnao") },
    { 0xCF, 0x00CF0224, _T("SPno") },
    { 0xD0, 0x00D00E0A, _T("PSDnoa") },
    { 0xD1, 0x00D1066A, _T("PSDPxoxn") },
    { 0xD2, 0x00D20705, _T("PDSnax") },
    { 0xD3, 0x00D307A4, _T("SPDSoaxn") },
    { 0xD4, 0x00D41D78, _T("SSPxPDxax") },
    { 0xD5, 0x00D50CE9, _T("DPSanan") },
    { 0xD6, 0x00D616EA, _T("PSDPSaoxx") },
    { 0xD7, 0x00D70349, _T("DPSxan") },
    { 0xD8, 0x00D80745, _T("PDSPxax") },
    { 0xD9, 0x00D906E8, _T("SDPSaoxn") },
    { 0xDA, 0x00DA1CE9, _T("DPSDanax") },
    { 0xDB, 0x00DB0D75, _T("SPxDSxan") },
    { 0xDC, 0x00DC0B04, _T("SPDnao") },
    { 0xDD, 0x00DD0228, _T("SDno") },
    { 0xDE, 0x00DE0268, _T("SDPxo") },
    { 0xDF, 0x00DF08C8, _T("SDPano") },
    { 0xE0, 0x00E003A5, _T("PDSoa") },
    { 0xE1, 0x00E10185, _T("PDSoxn") },
    { 0xE2, 0x00E20746, _T("DSPDxax") },
    { 0xE3, 0x00E306EA, _T("PSDPaoxn") },
    { 0xE4, 0x00E40748, _T("SDPSxax") },
    { 0xE5, 0x00E506E5, _T("PDSPaoxn") },
    { 0xE6, 0x00E61CE8, _T("SDPSanax") },
    { 0xE7, 0x00E70D79, _T("SPxPDxan") },
    { 0xE8, 0x00E81D74, _T("SSPxDSxax") },
    { 0xE9, 0x00E95CE6, _T("DSPDSanaxxn") },
    { 0xEA, 0x00EA02E9, _T("DPSao") },
    { 0xEB, 0x00EB0849, _T("DPSxno") },
    { 0xEC, 0x00EC02E8, _T("SDPao") },
    { 0xED, 0x00ED0848, _T("SDPxno") },
    { 0xEE, 0x00EE0086, _T("DSo SRCPAINT") },
    { 0xEF, 0x00EF0A08, _T("SDPnoo") },
    { 0xF0, 0x00F00021, _T("P PATCOPY") },
    { 0xF1, 0x00F10885, _T("PDSono") },
    { 0xF2, 0x00F20B05, _T("PDSnao") },
    { 0xF3, 0x00F3022A, _T("PSno") },
    { 0xF4, 0x00F40B0A, _T("PSDnao") },
    { 0xF5, 0x00F50225, _T("PDno") },
    { 0xF6, 0x00F60265, _T("PDSxo") },
    { 0xF7, 0x00F708C5, _T("PDSano") },
    { 0xF8, 0x00F802E5, _T("PDSao") },
    { 0xF9, 0x00F90845, _T("PDSxno") },
    { 0xFA, 0x00FA0089, _T("DPo") },
    { 0xFB, 0x00FB0A09, _T("DPSnoo PATPAINT") },
    { 0xFC, 0x00FC008A, _T("PSo") },
    { 0xFD, 0x00FD0A0A, _T("PSDnoo") },
    { 0xFE, 0x00FE02A9, _T("DPSoo") },
    { 0xFF, 0x00FF0062, _T("1 WHITENESS") },
};
#endif

/****************************************************************************
*                       CArrowButtonTestDlg::InitTrops
* Result: void
*       
* Effect: 
*       Initializes combo box of ternary raster ops
****************************************************************************/
#if 0
void CArrowButtonTestDlg::InitTrops()
    {
     for(int i = 0; i < 256; i++)
        { /* add it */
         int n = c_Rop3.AddString(trops[i].name);
         c_Rop3.SetItemData(n, trops[i].BLTOP);
        } /* add it */
     c_Rop3.SetCurSel(0);
    } // CArrowButtonTestDlg::InitTrops


void CArrowButtonTestDlg::OnCbnSelendokRop3()
    {
     c_Button.SetBlt((UINT)c_Rop3.GetItemData(c_Rop3.GetCurSel()));    }
#endif
    

void CArrowButtonTestDlg::OnEnChangeText()
    {
     CString s;
     c_Text.GetWindowText(s);
     c_Button.SetWindowText(s);
    }

void CArrowButtonTestDlg::OnBnClickedLeftAlign()
    {
     updateControls();
    }

void CArrowButtonTestDlg::OnBnClickedCenterAlign()
    {
     updateControls();
    }

void CArrowButtonTestDlg::OnBnClickedRightAlign()
    {
     updateControls();
    }

/****************************************************************************
*                    CArrowButtonTestDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the control the clipboard
****************************************************************************/

void CArrowButtonTestDlg::OnBnClickedCopy()
    {
     toClipboard(&c_Button);
    }
